<script lang="ts">
  import AcceptanceDescription from "./components/AcceptanceDescription.svelte";
  import GameCompleteDescription from "./components/GameCompleteDescription.svelte";
  import { flip } from "svelte/animate";
  import Player from "./components/Player.svelte";
  import { isActivePlayer, rotateUserLast } from "./utils";
  export let playerId: PlayerId | undefined;
  export let state: GameState;

  $: players = rotateUserLast(state.players, playerId);

  function getPlayerTransform(idx: number) {
    const rotationRad =
      Math.PI / 2 +
      ((2 * Math.PI) / players.length) * ((idx + 1) % players.length);
    const translateX = Math.cos(rotationRad) * 25;
    const translateY = Math.sin(rotationRad) * 25;

    return `transform: translate(-50%, -50%) translate(${translateX}rem, ${translateY}rem);`;
  }
</script>

<section>
  <div
    class="center"
    class:user={isActivePlayer(state, playerId) &&
      (state.phase[0] === "Giving" ||
        state.phase[0] === "Receiving" ||
        state.phase[0] === "Passing")}
  >
    {#if state.phase[0] === "Giving"}
      <i>
        <gs6-user userid={state.phase[1].giver} />
        <br />
        must give away a card.
      </i>
    {:else if state.phase[0] === "Receiving"}
      <i>
        <gs6-user userid={state.phase[1].claim.receiver} />
        <br />
        must accept the card or pass it.
      </i>
    {:else if state.phase[0] === "Acceptance"}
      <AcceptanceDescription phase={state.phase[1]} />
    {:else if state.phase[0] === "GameComplete"}
      <GameCompleteDescription
        players={state.players}
        loserId={state.phase[1].loser}
      />
    {/if}
  </div>
  <div class="players">
    {#each players as player, idx (player.id)}
      <div style={getPlayerTransform(idx)} animate:flip={{ duration: 400 }}>
        <Player userId={playerId} {state} {player} on:action />
      </div>
    {/each}
  </div>
</section>

<style>
  .center {
    position: absolute;
    top: 50%;
    left: 50%;
    transform: translate(-50%, -50%);

    max-width: 15rem;
    min-width: 12rem;
    text-align: center;
  }
  .center.user {
    top: calc(50% - 5.5rem);
    transform: translate(-50%, -100%);
  }

  .center > i {
    font-weight: 300;
  }

  .players > div {
    position: absolute;
    top: 50%;
    left: 50%;
    transform: translate(-50%, -50%);
  }
  .players > div:hover {
    z-index: 999;
  }
</style>
